Index: pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg.c
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg.c	(revision 1039)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg.c	(revision 1040)
@@ -527,5 +527,5 @@
 		     addr_len == sizeof(pj_sockaddr_in6), PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_ip_addr_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_ip_addr_attr);
     INIT_ATTR(attr, attr_type, STUN_GENERIC_IP_ADDR_LEN);
 
@@ -581,5 +581,5 @@
 
     /* Create the attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_ip_addr_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_ip_addr_attr);
     pj_memcpy(attr, buf, ATTR_HDR_LEN);
 
@@ -674,5 +674,5 @@
     PJ_ASSERT_RETURN(pool && value && p_attr, PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_string_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_string_attr);
     INIT_ATTR(attr, attr_type, value->slen);
     pj_strdup(pool, &attr->value, value);
@@ -713,5 +713,5 @@
 
     /* Create the attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_string_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_string_attr);
 
     /* Copy the header */
@@ -787,5 +787,5 @@
     PJ_ASSERT_RETURN(pool && p_attr, PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_empty_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_empty_attr);
     INIT_ATTR(attr, attr_type, sizeof(pj_stun_empty_attr));
 
@@ -806,5 +806,5 @@
 
     /* Create the attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_empty_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_empty_attr);
     pj_memcpy(attr, buf, ATTR_HDR_LEN);
 
@@ -865,5 +865,5 @@
     PJ_ASSERT_RETURN(pool && p_attr, PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_uint_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_uint_attr);
     INIT_ATTR(attr, attr_type, STUN_UINT_LEN);
     attr->value = value;
@@ -905,5 +905,5 @@
 
     /* Create the attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_uint_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_uint_attr);
     pj_memcpy(attr, buf, ATTR_LEN);
 
@@ -968,5 +968,5 @@
     PJ_ASSERT_RETURN(pool && p_attr, PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_msgint_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_msgint_attr);
     INIT_ATTR(attr, PJ_STUN_ATTR_MESSAGE_INTEGRITY, STUN_MSG_INTEGRITY_LEN);
 
@@ -1004,5 +1004,5 @@
 
     /* Create attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_msgint_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_msgint_attr);
     pj_memcpy(attr, buf, sizeof(pj_stun_msgint_attr));
     attr->hdr.type = pj_ntohs(attr->hdr.type);
@@ -1074,5 +1074,5 @@
     }
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_errcode_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_errcode_attr);
     INIT_ATTR(attr, PJ_STUN_ATTR_ERROR_CODE, 4+err_reason->slen);
     attr->err_class = (pj_uint8_t)(err_code / 100);
@@ -1110,5 +1110,5 @@
 
     /* Create the attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_errcode_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_errcode_attr);
 
     /* Copy the header */
@@ -1187,5 +1187,5 @@
     PJ_ASSERT_RETURN(pool && attr_cnt < PJ_STUN_MAX_ATTR && p_attr, PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_unknown_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_unknown_attr);
     INIT_ATTR(attr, PJ_STUN_ATTR_UNKNOWN_ATTRIBUTES, attr_cnt * 2);
 
@@ -1233,5 +1233,5 @@
     unsigned i;
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_unknown_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_unknown_attr);
     pj_memcpy(attr, buf, ATTR_HDR_LEN);
 
@@ -1310,5 +1310,5 @@
     PJ_ASSERT_RETURN(pool && attr_type && p_attr, PJ_EINVAL);
 
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_binary_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_binary_attr);
     INIT_ATTR(attr, attr_type, sizeof(pj_stun_binary_attr));
 
@@ -1352,5 +1352,5 @@
 
     /* Create the attribute */
-    attr = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_binary_attr);
+    attr = PJ_POOL_ZALLOC_T(pool, pj_stun_binary_attr);
 
     /* Copy the header */
@@ -1419,5 +1419,5 @@
     PJ_ASSERT_RETURN(pool && msg_type && p_msg, PJ_EINVAL);
 
-    msg = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_msg);
+    msg = PJ_POOL_ZALLOC_T(pool, pj_stun_msg);
     msg->hdr.type = (pj_uint16_t) msg_type;
     msg->hdr.magic = magic;
@@ -1606,5 +1606,5 @@
 
     /* Create the message, copy the header, and convert to host byte order */
-    msg = PJ_POOL_ZALLOC_TYPE(pool, pj_stun_msg);
+    msg = PJ_POOL_ZALLOC_T(pool, pj_stun_msg);
     pj_memcpy(&msg->hdr, pdu, sizeof(pj_stun_msg_hdr));
     msg->hdr.type = pj_ntohs(msg->hdr.type);